/* create data */
/* step one - block and e.u. variation */
/*  assuming natural block size        */
data natural_block;
seed=51722205;
block_var=0.5;
eu_var=1;
mu=0;
N_Natural_blocks=10;
natural_block_size=3;
do expt=1 to 1000;
 do natural_blk=1 to N_natural_blocks;
  blk_effect=sqrt(block_var)*rannor(seed);
  do eu=1 to Natural_Block_Size;
   e_ij=sqrt(eu_var)*rannor(seed);
   y=mu+blk_effect+e_ij;
   output;
  end;
 end;
end;
proc sort data=natural_block;
 by expt natural_blk eu;
run;
/* step 2 - match e.u. to block they will be in    */
/*  under incomplete and complete block design     */
/* also give trt under complete block              */
/* so variance estimation can account for trt d.f. */
data create_rcb;
 input natural_blk complete_blk @@;
   do eu=1 to 3;
    input trt @@;
     do expt=1 to 1000;
     output;
	 end;
   end;
datalines;
 1  1  1 2 3
 2  1  4 5 6
 3  2  1 2 3
 4  2  4 5 6
 5  3  1 2 3
 6  3  4 5 6
 7  4  1 2 3
 8  4  4 5 6
 9  5  1 2 3
10  5  4 5 6
;
proc sort data=create_rcb;
 by expt natural_blk eu;
run;
/* merge data sets */
data combined;
 merge natural_variation create_rcb;
 by expt natural_blk eu;
/* determine block and residual variance */
/*   for complete block design           */
ods results off;
ods html exclude all;
proc glimmix data=combined;
 by expt;
 class complete_blk trt;
 model y=trt ;
 random intercept / subject=complete_blk;
 ods output covparms=cb_var_est;
run;
proc sort data=cb_var_est;
 by covparm;
ods results on;
ods html select all;
proc means data=cb_var_est;
 by covparm;
 var estimate;
run;
